; +    
;4     + 1  ( )
; PPM
;: 
;           !  
;(C)   
;http://radioteh.nm.ru/


; !!!    16F628A   !!!


;=============================================
        LIST    p=16F628A           ; !!!   16F628A   !!!       
       __CONFIG b'11111100011100'
;                 32109876543210
;                 !!!!!!!!!!!!!+
;                 !!!!!!!!!!!!+-
;                 !!!!!!!!!!!+--WDT 
;                 !!!!!!!!!!+---PWRT 
;                 !!!!!!!!!+----
;                 !!!!!!!!+-----0-MCLR-  
;                 !!!!!!!+------0-Reset    
;                 !!!!!!+-------0-  
;                 !!!!!+--------1-  
;                 !!!!+---------\
;                 !!!+----------
;                 !!+-----------  
;                 !+------------/
;                 +-------------1-  


;=============================================

IndF        equ        00h         ;     FSR
Timer0      equ        01h         ; TMR0
OptionR     equ        01h         ; Option (RP0=1)
PC          equ        02h         ;  
Status      equ        03h         ; Status
FSR         equ        04h         ;   
PortA       equ        05h         ; Port A
TrisA       equ        05h         ; Tris A - RP0=1
PortB       equ        06h         ; Port B
TrisB       equ        06h         ; Tris B - RP0=1
PCLATH      equ        0ah
;            EEPROM
EEData      equ        1ah         ; EEPROM Data RP0=1
EEAdr       equ        1bh         ; EEPROM Address RP0=1
EECon1      equ        1ch         ; EECON1 - RP0=1
EECon2      equ        1dh         ; EECON2 - RP0=1

INTCon      equ        0bh
PCON        equ        0Eh         ;  RP0=1
SMCON       equ        1fh
PIR1        equ        0ch
PIE1        equ        0ch         ; RP0=1
TMR2        equ        11h         
PR2         equ        12h         ; RP0=1
T2CON       equ        12h
CCPR1L      equ        15h
CCPR1H      equ        16h
CCP1CON     equ        17h
;=============================================
;                                     
W           equ        0           ; 
F           equ        1           ; 
;
;=============================================
; Flag bits:
CF          equ        0           ; Carry
DC          equ        1           ; DC
ZF          equ        2           ; Zero
RP0         equ        5
RP1         equ        6
;=============================================

RBASE       equ        20h             ;  
            cblock     RBASE
            Temp 
            Count
            CountH     
            ldCount    
            TiMZ       
            Flags                     ; 
            Power                     ;   4 
            Beep                      ;  
            ki4lo
            ki4hi
            Paket
            endc

RBASE1      equ        70h             ;   
            cblock     RBASE1
            Adr                       ;  
            endc

; 
;      Flags      76543210
;                 1xxxxxxx   
;                 x1xxxxxx   
;                 xx1xxxxx  
;                 xxx1xxxx  
;                 xxxx1xxx  0   
;                 xxxxx1xx  0- 
;                 xxxxxx1x  1-4  - , 0 -  
;                 xxxxxxx1  1-    , 0- 



            ORG        0h


            nop
            nop
            nop
            nop

Start
            bsf        SMCON,0 
            bsf        SMCON,1 
            bsf        SMCON,2
            clrf       Paket
            clrf       Count
            clrf       CountH 
            clrf       PortA       ; RA0..RA3 = 0
            bsf        Status,RP0
            movlw      b'00010000'
            movwf      TrisA       ; RA0-RA3 output RA4 input
            movlw      b'00000000'
            movwf      TrisB       ; RB output

            bsf        OptionR,0   ;  
            bsf        OptionR,1   ;128
            bsf        OptionR,2
            bsf        OptionR,3   ;   WDT
            clrwdt
            bsf        PCON,3

            bcf        Status,RP0  ;
            movlw      b'00000000' ;
            movwf      PortB       ;B0-B7 =0
            movlw      b'00001111'
            movwf      PortA       ;B0-B3=1
;            
            clrf       Adr
            call       ReadEEPROM
;           movlw      b'00000010' ;!!!!!!!!!!!  
            movwf      Flags





;      
            
            movlw      0feh          ; 8 
            bsf        Status,RP0   ; 1
            movwf      PR2
            bcf        Status,RP0   ; 0

            movlw      00h          ; 0%
            movwf      CCPR1L       ;
            clrf       CCP1CON     
            
            movlw      b'00000100'  ;
            movwf      T2CON

            movlw      b'00001100'
            movwf      CCP1CON     




Sinhro     
            call       DetectSI    ;!!!!

;********** 1-  **************
                         
            bsf        PortB,0     ;      
            call       ki          ;  
detect1      
            btfsc      PortA,4     ;   
            goto       GRB1       ; 
            goto       detect1
            btfss      PortA,4    ;;        
            goto       detect1    ;  , 
GRB1
            bcf        PortB,0     ;      

;********** 2-  **************
            bsf        PortB,1     ;      
            call       ki          ;  
detect2      
            btfsc      PortA,4     ;   
            goto       GRB2       ; 
            goto       detect2
            btfss      PortA,4    ;;        
            goto       detect2    ;  , 

GRB2
            bcf        PortB,1     ;      

;********** 3-  **************
            bsf        PortB,2     ;      
            call       ki          ;  
detect3      
            btfsc      PortA,4     ;   
            goto       GRB3       ; 
            goto       detect3
            btfss      PortA,4    ;;        
            goto       detect3    ;  , 

GRB3
            bcf        PortB,2     ;      

;********** 4-  **************

;            btfss      Flags,1
;            goto       K4servo     ; Flags,1=0  
                                   ; - 
;*****************************************
;     4-    
;*****************************************

            call       ki          ;  

            movlw      0ffh         ;   
            movwf      Temp
            call Pause
            movlw      40h         ;   0  
            movwf      Temp
            call Pause



        ;  
            clrf       ki4lo
            clrf       ki4hi 

RegIzm

            incf       ki4lo,F
            btfsc      Status,ZF 
            incf       ki4hi,F
            btfsc      PortA,4
            goto       RegIzm
        ; 


;            btfsc      Flags,0     ; Flags,0=0   
;            goto       kalibrovka  ; 



 ; ***************!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 ;                       

 ; ************************************************
            movf       ki4hi,W
            btfss      Status,ZF  ; 
            goto       Full
 
            decf       ki4lo,F
            call       PWMTab       ;      
            movwf      CCPR1L       ;    
            clrf       PCLATH       ;
            goto       Sinhro


Full        ;    FFh

            movlw      0ffh         ; 100%
            movwf      CCPR1L       ;
            goto       Sinhro

kalibrovka
 
            movf       Paket,W    ; W-06
            sublw      02h        ; CountH>6h 
            btfsc      Status,CF  ; 
            goto       Sinhro     ;, 
           

            movlw      03h
            movwf      Adr
            movf       ki4lo,W
            call       SaveEEPROM
            call       ld

            call       ld
            movlw      04h
            movwf      Adr
            movf       ki4hi,W
            call       SaveEEPROM
            bcf        Flags,0
            

            call       ld
            bcf        Flags,0
            movlw      00h
            movwf      Adr
            movf       Flags,W
            call       SaveEEPROM


            goto       K5         ;

;*****************************************
;     4-   
;*****************************************

            
K4servo
            bsf        PortB,3     ;      
            call       ki          ;  

detect4      
            btfsc      PortA,4     ;   
            goto       GRB4       ; 
            goto       detect4


GRB4
            bcf        PortB,3     ;      

;********** 5-  **************

K5
            bsf        PortB,4     ;      
            call       ki          ;  
detect5      
            btfsc      PortA,4     ;   
            goto       GRB2       ; 
            goto       detect5
            btfss      PortA,4    ;;        
            goto       detect5    ;  , 

GRB5
            bcf        PortB,4     ;      






        
            goto       Sinhro




;********************************************
;*                               *
;********************************************

;-------------------------------------------------
;      
;-------------------------------------------------   
p1
            movf       TiMZ,W   
            movwf      Temp
Pause
            decfsz     Temp,F
            goto       Pause
            return


ld          movlw      0ffh
            movwf      Count
dellay 
            movlw      0ffh
            movwf      Temp
            call       Pause
            decfsz     Count,F
            goto       dellay
            return

;-------------------------------------------------
; 
;------------------------------------------------
DetectSI

            clrf       Count
            clrf       CountH 
            btfsc      PortA,4 ; 1
            goto       $-1
            ;  
ChkSinhro

            incf       Count,F
            btfsc      Status,ZF 
            incf       CountH,F
            btfss      PortA,4
            goto       ChkSinhro
            
            ;  PortA,4   1  0
            movf       CountH,W   ; W-03
            sublw      03h        ; CountH>3h 
            btfsc      Status,CF  ; 
            goto       sinherror  ; , 
            incf       Paket,F
            return                ; 

sinherror   clrf       Paket
            goto       DetectSI   ; ,  
;-------------------------------------------------
;  
;------------------------------------------------
ki          
            btfsc      PortA,4
            goto       ki
            btfsc      PortA,4  ;        
            goto       ki

            clrwdt              ; WatchDog 
            return

;*******************************************************
;  W  EEPROM 
;***********************************
SaveEEPROM
            bcf        PIR1,7
            bsf        Status,RP0   ; 1
            movwf      EEData   ;   ;
            movf       Adr,W
            movwf      EEAdr    ;
            bsf        EECon1,2     ; 
            bcf        INTCon,7
            movlw      55h
            movwf      EECon2
            movlw      0AAh
            movwf      EECon2
            bsf        EECon1,1       ; WR ,  
            bcf        Status,RP0     ; 0
            bsf        INTCon,7
            return
;*****************************************************************
;     EEPROM
;*****************************************************************
ReadEEPROM
            
            movf       Adr,W       ;
            bsf        Status,RP0  ;Bank 1
            movwf      EEAdr       ;Address to read
            bsf        EECon1,0
            movf       EEData,W    ;W = EEDATA 
            bcf        Status,RP0  ;Bank 0
            return


;*****************************************************************
;     
;  628  :)
;*****************************************************************
            ORG        1fch
PWMTab      
            movlw      02h          ;
            movwf      PCLATH       ;
            movf       ki4lo,W
            addwf      PC,F        ; W + PC -> PC
            retlw      00h         ;0
            retlw      00h         ;1
            retlw      00h         ;2
            retlw      00h         ;3
            retlw      00h         ;4
            retlw      00h         ;5
            retlw      00h         ;6
            retlw      00h         ;7
            retlw      00h         ;8
            retlw      00h         ;9
            retlw      00h         ;a
            retlw      00h         ;b
            retlw      00h         ;c
            retlw      00h         ;d
            retlw      00h         ;e
            retlw      00h         ;f
            retlw      00h         ;10h
            retlw      00h         ;11h
            retlw      00h         ;12h
            retlw      00h         ;13h
            retlw      00h         ;14h
            retlw      00h         ;15h
            retlw      00h         ;16h   
            retlw      00h         ;17h   
            retlw      00h         ;18h   
            retlw      00h         ;19h   
            retlw      00h         ;1ah   
            retlw      00h         ;1dh
            retlw      00h         ;1ch
            retlw      00h         ;1dh
            retlw      00h         ;1eh
            retlw      00h         ;1fh
            retlw      00h         ;20h   
            retlw      00h         ;21h  
            retlw      00h         ;22h  
            retlw      00h         ;23h  
            retlw      00h         ;24
            retlw      00h         ;25
            retlw      00h         ;26
            retlw      00h         ;27
            retlw      00h         ;28
            retlw      28h         ;29  15%
            retlw      2ah         ;2a
            retlw      2ch         ;2b
            retlw      2eh         ;2c
            retlw      31h         ;2d
            retlw      33h         ;2e  20%
            retlw      35h         ;2f
            retlw      37h         ;30
            retlw      39h         ;31
            retlw      3ah         ;32
            retlw      3ch         ;33
            retlw      3eh         ;34
            retlw      40h         ;35
            retlw      42h         ;36
            retlw      44h         ;37
            retlw      46h         ;38
            retlw      48h         ;39
            retlw      4ah         ;3a
            retlw      4ch         ;3b   30%
            retlw      4eh         ;3c
            retlw      50h         ;3d
            retlw      52h         ;3e
            retlw      54h         ;3f
            retlw      56h         ;40
            retlw      58h         ;41
            retlw      5ah         ;42
            retlw      5ch         ;43     
            retlw      5eh         ;44
            retlw      60h         ;45
            retlw      62h         ;56
            retlw      64h         ;47
            retlw      66h         ;48     40%
            retlw      67h         ;49
            retlw      68h         ;4a
            retlw      69h         ;4b
            retlw      6ah         ;4c
            retlw      6bh         ;4d
            retlw      6ch         ;4e
            retlw      6dh         ;4f
            retlw      6eh         ;50     
            retlw      6fh         ;51
            retlw      70h         ;52
            retlw      71h         ;53
            retlw      72h         ;54
            retlw      73h         ;55
            retlw      74h         ;56
            retlw      75h         ;57
            retlw      76h         ;58
            retlw      77h         ;59
            retlw      78h         ;5a
            retlw      79h         ;5b
            retlw      7ah         ;5c
            retlw      7bh         ;5d
            retlw      7ch         ;5e
            retlw      7dh         ;5f
            retlw      7eh         ;60
            retlw      7fh         ;61    50%
            retlw      80h         ;62
            retlw      81h         ;63
            retlw      82h         ;64
            retlw      83h         ;65
            retlw      84h         ;66
            retlw      85h         ;67
            retlw      86h         ;68
            retlw      87h         ;69
            retlw      88h         ;6a
            retlw      89h         ;6b
            retlw      8ah         ;6c
            retlw      8bh         ;6d
            retlw      8ch         ;6e
            retlw      8dh         ;6f
            retlw      8eh         ;70
            retlw      8fh         ;71     
            retlw      90h         ;72
            retlw      91h         ;73
            retlw      92h         ;74
            retlw      93h         ;75
            retlw      94h         ;76
            retlw      95h         ;77
            retlw      96h         ;78
            retlw      97h         ;79
            retlw      98h         ;7a
            retlw      99h         ;7b
            retlw      9ah         ;7c
            retlw      9bh         ;7d
            retlw      9ch         ;7e
            retlw      9dh         ;7f
            retlw      9eh         ;80
            retlw      9fh         ;81     
            retlw      0a0h         ;82
            retlw      0a1h         ;83
            retlw      0a2h         ;84
            retlw      0a3h         ;85
            retlw      0a4h         ;84
            retlw      0a5h         ;87
            retlw      0a6h         ;88
            retlw      0a7h         ;89
            retlw      0a8h         ;8a
            retlw      0a9h         ;8b
            retlw      0aah         ;8c
            retlw      0abh         ;8d
            retlw      0ach         ;8e
            retlw      0adh         ;8f
            retlw      0aeh         ;90
            retlw      0afh         ;91     
            retlw      0b0h         ;92
            retlw      0b1h         ;93
            retlw      0b2h         ;94
            retlw      0b3h         ;95
            retlw      0b4h         ;94
            retlw      0b5h         ;97
            retlw      0b6h         ;98
            retlw      0b7h         ;99
            retlw      0b8h         ;9a
            retlw      0b9h         ;9b
            retlw      0bah         ;9c
            retlw      0bbh         ;9d
            retlw      0bch         ;9e
            retlw      0bdh         ;9f
            retlw      0beh         ;a0
            retlw      0bfh         ;a1
            retlw      0c0h         ;a2
            retlw      0c1h         ;a3
            retlw      0c2h         ;a4
            retlw      0c3h         ;a5
            retlw      0c4h         ;a4
            retlw      0c5h         ;a7
            retlw      0c6h         ;a8
            retlw      0c7h         ;a9
            retlw      0c8h         ;aa
            retlw      0c9h         ;ab
            retlw      0cah         ;ac
            retlw      0cbh         ;ad
            retlw      0cch         ;ae
            retlw      0cdh         ;af
            retlw      0ceh         ;b0
            retlw      0cfh         ;b1     
            retlw      0d0h         ;b2
            retlw      0d1h         ;b3
            retlw      0d2h         ;b4
            retlw      0d3h         ;b5
            retlw      0d4h         ;b4
            retlw      0d5h         ;b7
            retlw      0d6h         ;b8
            retlw      0d7h         ;b9
            retlw      0d8h         ;ba
            retlw      0d9h         ;bb
            retlw      0dah         ;bc
            retlw      0dbh         ;bd
            retlw      0dch         ;be
            retlw      0ddh         ;bf
            retlw      0deh         ;c0
            retlw      0dfh         ;cb1     
            retlw      0e0h         ;c2
            retlw      0e1h         ;c3
            retlw      0e2h         ;c4
            retlw      0e3h         ;c5
            retlw      0e4h         ;c4
            retlw      0e5h         ;c7
            retlw      0e6h         ;c8
            retlw      0e7h         ;c9
            retlw      0e8h         ;ca
            retlw      0e9h         ;cb
            retlw      0eah         ;cc
            retlw      0ebh         ;cd
            retlw      0ech         ;ce
            retlw      0edh         ;cf
            retlw      0eeh         ;d0
            retlw      0efh         ;d1     
            retlw      0f0h         ;d2
            retlw      0f1h         ;d3
            retlw      0f2h         ;d4
            retlw      0f3h         ;d5
            retlw      0f4h         ;d4
            retlw      0f5h         ;d7
            retlw      0f6h         ;d8
            retlw      0f7h         ;d9
            retlw      0f8h         ;da
            retlw      0f9h         ;db
            retlw      0fah         ;dc
            retlw      0fbh         ;dd
            retlw      0fch         ;de
            retlw      0fdh         ;df
            retlw      0feh         ;e0
            retlw      0ffh         ;e1     
            retlw      0f0h         ;e2
            retlw      0f1h         ;e3
            retlw      0f2h         ;e4
            retlw      0f3h         ;e5
            retlw      0f4h         ;e4
            retlw      0f5h         ;e7
            retlw      0f6h         ;e8
            retlw      0f7h         ;e9
            retlw      0f8h         ;ea
            retlw      0f9h         ;eb
            retlw      0fah         ;ec
            retlw      0fbh         ;ed
            retlw      0fch         ;ee
            retlw      0fdh         ;ef
            retlw      0feh         ;f0
            retlw      0ffh         ;f1   100%
            retlw      0ffh         ;f2
            retlw      0ffh         ;f3
            retlw      0ffh         ;f4
            retlw      0ffh         ;f5
            retlw      0ffh         ;f4
            retlw      0ffh         ;f7
            retlw      0ffh         ;f8
            retlw      0ffh         ;f9
            retlw      0ffh         ;fa
            retlw      0ffh         ;fb
            retlw      0ffh         ;fc
            retlw      0ffh         ;fd
            retlw      0ffh         ;fe
            retlw      0ffh         ;ff




  
     





            end
